﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace MultiSelectFilterCSharp
{
    public partial class FilterForm : Form
    {
        
        FarPoint.Win.Spread.FpSpread tempSpread;
        private ArrayList al;
        Form1 parent;
        public FilterForm()
        {
            InitializeComponent();
        }
        public FilterForm(ListBox lb, FarPoint.Win.Spread.FpSpread fS, Form1 f)
        {
            InitializeComponent();
            for (int i = 0; i < lb.Items.Count; i++)
            {
                this.listBox1.Items.Add(lb.Items[i]);
            }

            this.listBox1.SelectionMode = SelectionMode.MultiSimple;
            tempSpread = fS;
            parent = f;
            al = new ArrayList();
        }
        public ArrayList rows {
            get
            {
                return this.al;
            }
            set
            {
                this.al = value;
            }
        }
        private void FilterForm_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            ListBox.SelectedIndexCollection sindexes = this.listBox1.SelectedIndices;
            if (sindexes.Count == 1 && this.listBox1.SelectedItem.Equals("All"))
            {
                al.Add("All");
            }
            else
            {
                for (int r = 0; r < tempSpread.ActiveSheet.RowCount; r++)
                {
                    bool visible = false;
                    for (int s = 0; s < sindexes.Count; s++)
                    {
                        if (this.listBox1.Items[sindexes[s]].Equals(tempSpread.ActiveSheet.Cells[r, tempSpread.ActiveSheet.ActiveColumnIndex].Value))
                        {
                            visible = true;
                            break;
                        }
                    }
                    if (visible)
                    {
                        al.Add(r);
                    }
                }
            }
            parent.SetRows(al);
            this.Close();
        }
    }
}

