﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace MultiSelectFilterCSharp
{
    public partial class Form1 : Form
    {
        private ArrayList fal;
        public ArrayList prows
        {
            get
            {
                return this.fal;
            }
            set
            {
                this.fal = value;
            }
        }
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           
        }

        private void button1_Click(object sender, EventArgs e)
            {
                listBox1.Items.Clear();   
                bool present = false;
                listBox1.SelectionMode = SelectionMode.MultiSimple;
                for (int r = 0; r < fpSpread1.Sheets[0].RowCount; r++)
                {
                    if (listBox1.Items.Count != 0)
                    {
                        for (int i = 0; i < listBox1.Items.Count; i++)
                        {
                            if (listBox1.Items[i].Equals(fpSpread1.Sheets[0].Cells[r, fpSpread1.ActiveSheet.ActiveColumnIndex].Value))
                            {
                                present = true;
                                break;
                            }
                            else
                            {
                                present = false;
                               
                            }
                        }
                        if (!present)
                        {
                            listBox1.Items.Add(fpSpread1.Sheets[0].Cells[r, fpSpread1.ActiveSheet.ActiveColumnIndex].Value);
                        }
                    }
                    else
                        listBox1.Items.Add(fpSpread1.Sheets[0].Cells[r, fpSpread1.ActiveSheet.ActiveColumnIndex].Value);
                } 
                listBox1.Items.Add("All");
                FilterForm f1 = new FilterForm(listBox1, fpSpread1, this);
                f1.Show();
                f1.FormClosed += new FormClosedEventHandler(f1_FormClosed);
         }

        void f1_FormClosed(object sender, FormClosedEventArgs e)
        {
            bool visible = false;
            if (fal.Count == 1 && fal[0].Equals("All"))
            {
                for (int r = 0; r < fpSpread1.ActiveSheet.Rows.Count; r++)
                {
                    fpSpread1.ActiveSheet.Rows[r].Visible = true;
                }
            }
            else
            {
                for (int r = 0; r < fpSpread1.ActiveSheet.RowCount; r++)
                {

                    for (int i = 0; i < this.fal.Count; i++)
                    {
                        if (fal[i].Equals(r))
                        {
                            visible = true;
                            break;
                        }
                        else
                        {
                            visible = false;
                        }
                    }
                    if (visible)
                    {
                        fpSpread1.ActiveSheet.Rows[r].Visible = true;
                    }
                    else
                    {
                        fpSpread1.ActiveSheet.Rows[r].Visible = false;
                    }
                }
            }
        }
       public void SetRows(ArrayList al)
        {
            this.fal = al;
        }
    }
}


